import { connect, Dispatch } from 'react-redux';
import {
    NotificationModal,
    StateProps as StateProps,
    DispatchProps as DispatchProps,
} from './components/Notification';
import { push as routerPush } from 'react-router-redux';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
import Member from '@overflow/member/api/model/Member';
import * as readAllUnconfirmedActions from '../redux/action/read_all_unconfirmed';

export function mapStateToProps(state: any, props: StateProps): StateProps {
    return {
        notifications: state.notifications,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
    return {
        onReadAllUnconfirmed: (member: Member, pageNo: string, countPerPage: string) => {
            dispatch(asyncRequestActions.request('NotificationService', 'readAllUnconfirmedByMember',
                                                 readAllUnconfirmedActions.REQUEST, JSON.stringify(member), pageNo, countPerPage));
        },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(NotificationModal);

